#------------------------------------------------------------------------------
# HATE script to evaluate an edge detector
#------------------------------------------------------------------------------
# Note that this is an example of how to write test scripts: it is deliberately
# naive in the approach it takes to testing.
# The result should be one true negative and 39 false negative, though the
# differences in random number generation on your system may make this vary.
#------------------------------------------------------------------------------


#------------------------------------------------------------------------------
# HATE_DescribeTests -- describe the tests that this script performs
#------------------------------------------------------------------------------

proc HATE_DescribeTests {} {
    HATE_Line "This script tests an edge detector by determining how many"
    HATE_Line "edge pixels are found.  It changes the amplitude of the edge,"
    HATE_Line "the global image offset, and the amount of additive noise."
    HATE_Line "WARNING: This is a example only -- you are not recommended to"
    HATE_Line "         use this script to perform serious testing!"
}


#------------------------------------------------------------------------------
# HATE_RunTests -- execute the tests
#------------------------------------------------------------------------------

proc HATE_RunTests {} {
    set testno 0

    # Run a set of tests changing the edge amplitude
    for {set amp 1} {$amp < 150} {set amp [expr $amp + 10]} {
	incr testno
	set testname edge-$testno

	# We expect the edge not to be spotted for an amplitude less than 10;
	# otherwise, it should be found.
	if {$amp < 10} {
	    set passfail 0
	} else {
	    set passfail 1
	}
	HATE_Test $testname $passfail "-amplitude $amp" "509 65027"
    }

    # Run a set of tests changing the image offset
    for {set offset 0} {$offset < 150} {set offset [expr $offset + 10]} {
	incr testno
	set testname edge-$testno
	HATE_Test $testname 1 "-amplitude 30 -offset $offset" "509 65027"
    }

    # Run a set of tests of increasing noise
    for {set sd 1} {$sd < 20} {set sd [expr $sd + 2]} {
	incr testno
	set testname edge-$testno
	HATE_Test $testname 1 "-amplitude 30 -offset 100 -noisy -noise-sd $sd" "509 65027"
    }
}
